SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
centimeter
	
	^Unit centimeters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
decameter
	
	^Unit decameters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
decimeter
	
	^Unit decimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
hectometer
	
	^Unit hectometers.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
kilometer
	
	^Unit kilometers.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
meter

	^Unit meters.! !

!DistanceTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/2/2012 18:13'!
millimeter
	
	^Unit millimeters.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
minusOneMeter 
	
	^Measure in: Unit meters withAMagnitudeOf: -1.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
oneCentimeter
	
	^Measure in: Unit centimeters withAMagnitudeOf: 1.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
oneHundredCentimeters
	
	^Measure in: Unit centimeters withAMagnitudeOf: 100.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
oneMeter
	
	^Measure in: Unit meters withAMagnitudeOf: 1.! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:59'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 01:00'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:23'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter magnitude = 1.
	self assert: self twoMeters magnitude = 2.
	self assert: self oneHundredCentimeters magnitude = 100.
	self assert: self twoHundredCentimeters magnitude = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07bDistanceUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'GuillermoAres 5/22/2012 00:30'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance expressedIn: self meter) magnitude = 1.
		self assert: (aDistance expressedIn: self meter) unit = self meter.
		
		self assert: (aDistance expressedIn: self decimeter) magnitude = 10.
		self assert: (aDistance expressedIn: self decimeter) unit = self decimeter.
		
		self assert: (aDistance expressedIn: self centimeter) magnitude = 100.
		self assert: (aDistance expressedIn: self centimeter) unit = self centimeter.
		
		self assert: (aDistance expressedIn: self millimeter) magnitude = 1000.
		self assert: (aDistance expressedIn: self millimeter) unit = self millimeter.
	
		self assert: (aDistance expressedIn: self decameter) magnitude = (1/10).
		self assert: (aDistance expressedIn: self decameter) unit = self decameter.
		
		self assert: (aDistance expressedIn: self hectometer) magnitude = (1/100).
		self assert: (aDistance expressedIn: self hectometer) unit = self hectometer.
	
		self assert: (aDistance expressedIn: self kilometer) magnitude = (1/1000).
		self assert: (aDistance expressedIn: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 01:31'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) magnitude = (2/3).
	self assert: (self twoMeters * (2/3)) magnitude = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 01:31'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) magnitude = 2.5.
	self assert: (self twoMeters * 2.5) magnitude = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/2/2012 19:20'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 00:23'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) magnitude = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 5/22/2012 00:23'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) magnitude = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:33'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:34'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:36'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'GuillermoAres 5/22/2012 01:37'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 6/6/2012 06:49'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 6/6/2012 06:49'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 5/22/2012 00:23'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance magnitude = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 5/22/2012 00:23'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance magnitude.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance magnitude = value.
		value := value + byDistance magnitude ].
	
	self assert:  value = (finalDistance magnitude + byDistance magnitude)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
twoHundredCentimeters
	
	^Measure in: Unit centimeters withAMagnitudeOf: 200.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
twoMeters
	
	^Measure in: Unit meters withAMagnitudeOf: 2.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
zeroMeters

	^Measure in: Unit meters withAMagnitudeOf: 0.! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'GuillermoAres 6/4/2012 01:00'!
canNotConvertMeasurementException
	
	^CanNotConvertMeasurement.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GuillermoAres 6/5/2012 01:13'!
celsius
	
	^Unit celsius.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:11'!
centimeter
	
	^Unit centimeters.! !

!MeasureTest methodsFor: 'time units' stamp: 'GuillermoAres 6/5/2012 01:13'!
day
	
	^Unit days.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:12'!
decameter
	
	^Unit decameters.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:11'!
decimeter
	
	^Unit decimeters.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 03:01'!
eightCubicMeters

	^Measure in: Unit meters * Unit meters * Unit meters withAMagnitudeOf: 8.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GuillermoAres 6/5/2012 01:13'!
fahrenheit
	
	^Unit fahrenheits.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 05:39'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^initialSpeed + ( anAcceleration * aTimePeriod).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 03:00'!
fourSquaredMeters

	^Measure in: Unit meters * Unit meters withAMagnitudeOf: 4.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:12'!
hectometer
	
	^Unit hectometers.! !

!MeasureTest methodsFor: 'time units' stamp: 'GuillermoAres 6/5/2012 01:15'!
hour
	
	^Unit hours.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'GuillermoAres 6/5/2012 01:26'!
kelvin
	
	^Unit kelvins.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:12'!
kilometer
	
	^Unit kilometers.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:11'!
meter

	^Unit meters.! !

!MeasureTest methodsFor: 'distance units' stamp: 'GuillermoAres 6/5/2012 01:12'!
millimeter
	
	^Unit millimeters.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 06:03'!
minusOneMeter 
	
	^Measure in: Unit meters withAMagnitudeOf: -1.! !

!MeasureTest methodsFor: 'time units' stamp: 'GuillermoAres 6/5/2012 01:16'!
minute
	
	^Unit minutes.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
oneCelsius
	
	^Measure in: Unit celsius withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 06:03'!
oneCentimeter
	
	^Measure in: Unit centimeters withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:30'!
oneDay
	
	^Measure in: Unit days withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:29'!
oneHour
	
	^Measure in: Unit hours withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
oneHundredCentimeters
	
	^Measure in: Unit centimeters withAMagnitudeOf: 100.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 05:44'!
oneHundredTwentyOneMetersPerSecond

	^Measure in: Unit meters * Unit seconds withAMagnitudeOf: 121.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
oneMeter
	
	^Measure in: Unit meters withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 05:38'!
oneMeterPerSecond

	^Measure in: Unit meters * Unit seconds withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
oneMinute
	
	^Measure in: Unit minutes withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/6/2012 07:20'!
oneSecond

	^Measure in: Unit seconds withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/5/2012 20:48'!
oneSquaredMeter

	^Measure in: Unit meters * Unit meters withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 03:02'!
oneSquaredSecond

	^Measure in: Unit seconds * Unit seconds withAMagnitudeOf: 1.! !

!MeasureTest methodsFor: 'time units' stamp: 'GuillermoAres 6/5/2012 01:17'!
second
	
	^Unit seconds.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:30'!
sixtyMinutes

	^Measure in: Unit minutes withAMagnitudeOf: 60.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:32'!
sixtyOneSeconds
	
	^Measure in: Unit seconds withAMagnitudeOf: 61.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
sixtySeconds
	
	^Measure in: Unit seconds withAMagnitudeOf: 60.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:12'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:19'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:24'!
test07aMeasureMagnitudeShouldBeTheExpectedMagnitude

	self assert: self oneMeter magnitude = 1.
	self assert: self twoMeters magnitude = 2.
	self assert: self oneHundredCentimeters magnitude = 100.
	self assert: self twoHundredCentimeters magnitude = 200.

	self assert: self oneMinute magnitude = 1.
	self assert: self sixtySeconds magnitude = 60.
	
	self assert: self zeroCelsius magnitude = 0.
	self assert: self thirtyTwoFahrenheits magnitude = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 22:47'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el magnitude y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance expressedIn: self meter) magnitude = 1.
		self assert: (aDistance expressedIn: self meter) unit = self meter.
		
		self assert: (aDistance expressedIn: self decimeter) magnitude = 10.
		self assert: (aDistance expressedIn: self decimeter) unit = self decimeter.
		
		self assert: (aDistance expressedIn: self centimeter) magnitude = 100.
		self assert: (aDistance expressedIn: self centimeter) unit = self centimeter.
		
		self assert: (aDistance expressedIn: self millimeter) magnitude = 1000.
		self assert: (aDistance expressedIn: self millimeter) unit = self millimeter.
	
		self assert: (aDistance expressedIn: self decameter) magnitude = (1/10).
		self assert: (aDistance expressedIn: self decameter) unit = self decameter.
		
		self assert: (aDistance expressedIn: self hectometer) magnitude = (1/100).
		self assert: (aDistance expressedIn: self hectometer) unit = self hectometer.
	
		self assert: (aDistance expressedIn: self kilometer) magnitude = (1/1000).
		self assert: (aDistance expressedIn: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:28'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute expressedIn: self second) = self sixtySeconds.
	self assert: (self sixtySeconds expressedIn: self minute) = self oneMinute.

	self assert: (self oneHour expressedIn: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes expressedIn: self hour) = self oneHour.

	self assert: (self oneDay expressedIn: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours expressedIn: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:28'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius expressedIn: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits expressedIn: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'GuillermoAres 6/5/2012 01:28'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter expressedIn: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond expressedIn: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius expressedIn: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/6/2012 06:29'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: (aMeasure negated) magnitude = aMeasure magnitude negated negated]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/4/2012 01:03'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) magnitude = (2/3).
	self assert: (self twoMeters * (2/3)) magnitude = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) magnitude = (2/3).
	self assert: (self twoSeconds * (2/3)) magnitude = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) magnitude = (2/3).
	self assert: (self twoCelsius * (2/3)) magnitude = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/4/2012 01:03'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) magnitude = 2.5.
	self assert: (self twoMeters * 2.5) magnitude = (2 * 2.5).

	self assert: (self oneSecond * 2.5) magnitude = 2.5.
	self assert: (self twoSeconds * 2.5) magnitude = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) magnitude = 2.5.
	self assert: (self twoCelsius * 2.5) magnitude = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/5/2012 01:25'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) magnitude = 6.
	self assert: (self twoSeconds / (1/3)) magnitude = 6.
	self assert: (self twoCelsius / (1/3)) magnitude = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/5/2012 01:25'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) magnitude = (2/2.5).
	self assert: (self twoSeconds / 2.5) magnitude = (2/2.5).
	self assert: (self twoCelsius / 2.5) magnitude = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'GuillermoAres 6/6/2012 05:57'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 6/5/2012 01:25'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure magnitude = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'GuillermoAres 6/5/2012 01:26'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance magnitude.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure magnitude = value.
		value := value + byDistance magnitude ].
	
	self assert:  value = (finalDistance magnitude + byDistance magnitude)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'GuillermoAres 6/5/2012 22:46'!
test33NothingOnAnyDomainAreEquals

	self deny: self zeroMeters = self zeroSeconds.
	self deny: self zeroSeconds = self zeroKelvin.
	self deny: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
thirtyTwoFahrenheits
	
	^Measure in: Unit fahrenheits withAMagnitudeOf: 32.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:31'!
twentyFourHours
	
	^Measure in: Unit hours withAMagnitudeOf: 24.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuillermoAres 6/5/2012 01:31'!
twoCelsius
	
	^Measure in: Unit celsius withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
twoHundredCentimeters
	
	^Measure in: Unit centimeters withAMagnitudeOf: 200.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
twoMeters
	
	^Measure in: Unit meters withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 05:50'!
twoMetersBySecond

	^Measure in: Unit meters / Unit seconds withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 08:25'!
twoMetersPerSquaredSecond

	^Measure in: Unit meters / (Unit seconds * Unit seconds) withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'GuillermoAres 6/6/2012 02:14'!
twoMetersTimesSecond

	^Measure in: Unit meters * Unit seconds withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:31'!
twoSeconds
	
	^Measure in: Unit seconds withAMagnitudeOf: 2.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuillermoAres 6/6/2012 07:21'!
zeroCelsius
	
	^Measure in: Unit celsius withAMagnitudeOf: 0.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GuillermoAres 6/5/2012 22:46'!
zeroKelvin
	
	^Measure in: Unit kelvins withAMagnitudeOf: 0.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GuillermoAres 6/5/2012 01:32'!
zeroMeters

	^Measure in: Unit meters withAMagnitudeOf: 0.! !

!MeasureTest methodsFor: 'time measures' stamp: 'GuillermoAres 6/5/2012 01:32'!
zeroSeconds
	
	^Measure in: Unit seconds withAMagnitudeOf: 0.! !

Error subclass: #CanNotConvertMeasurement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Object subclass: #ColoquialForPotenciesDictionary
	instanceVariableNames: 'coloquialsForPotencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ColoquialForPotenciesDictionary methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 02:38'!
initialize

	coloquialsForPotencies := Array 
									with: ''
									with: 'squared'
									with: 'cubic'.! !

!ColoquialForPotenciesDictionary methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 02:07'!
of: aPotence

	^coloquialsForPotencies at: aPotence.! !

Object subclass: #FactorContainer
	instanceVariableNames: 'factors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!FactorContainer methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 09:01'!
= anotherFactorContainer

	^(factors allSatisfy: [ :each | (self potenceOf: each) = (anotherFactorContainer potenceOf: each)]) 
		and: (self bases allSatisfy: [ :selfBase | anotherFactorContainer bases contains: [ :aBase | aBase = selfBase ]])
		and: (anotherFactorContainer bases allSatisfy: [ :aBase | self bases contains: [ :selfBase | aBase = selfBase ]])! !

!FactorContainer methodsFor: 'adding' stamp: 'GuillermoAres 6/6/2012 05:13'!
add: aPotenceName 

	factors add: aPotenceName.! !

!FactorContainer methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 09:08'!
bases

	| aSet |
	
	aSet := Set new.

	(factors collect: [ :each | each base]) do: [ :each | aSet add: each].
	^aSet size.! !

!FactorContainer methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 08:16'!
initialize

	^factors := OrderedCollection new.! !

!FactorContainer methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 09:05'!
potenceOf: aBase

	^(factors collect: [ :each | each base = aBase]) sum: [ :each | each potence].! !

Object subclass: #HumanReadableMathematicalName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!HumanReadableMathematicalName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 01:10'!
forProductBetween: aMathematicalName and: anotherMathematicalName

	^aMathematicalName * anotherMathematicalName.! !

!HumanReadableMathematicalName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 03:12'!
forRatioBetween: aMathematicalName and: anotherMathematicalName

	^aMathematicalName / anotherMathematicalName.! !

!HumanReadableMathematicalName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 00:56'!
knownAs: aName 
	
	^HumanReadablePotenceName knownAs: aName.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:41'!
* anotherMathematicalName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:40'!
/ anotherMathematicalName.

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 08:36'!
= anotherHumanReadableMathematicalName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'converting' stamp: 'GuillermoAres 6/6/2012 01:47'!
asString

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:32'!
dividedByThePotenceName: aPotenceName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:03'!
dividedByTheProductName: aProductName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:06'!
dividedByTheRatioName: aRatioName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 03:58'!
multipliedByThePotenceName: aPotenceName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:02'!
multipliedByTheProductName: aProductName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:06'!
multipliedByTheRatioName: aRatioName

	^self subclassResponsibility.! !

!HumanReadableMathematicalName methodsFor: 'printing' stamp: 'GuillermoAres 6/6/2012 02:47'!
printOn: aStream
	
	aStream nextPutAll: self asString.! !

HumanReadableMathematicalName subclass: #HumanReadablePotenceName
	instanceVariableNames: 'base potence coloquialForPotencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!HumanReadablePotenceName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 02:11'!
knownAs: aName 
	
	^HumanReadablePotenceName new
		base: aName;
		potence: 1.! !

!HumanReadablePotenceName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 02:51'!
named: aName withAPotenceOf: aPotence 

	^HumanReadablePotenceName new
		base: aName;
		potence: aPotence.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 05:23'!
* anotherMathematicalName 

	^anotherMathematicalName multipliedByThePotenceName: self.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 03:57'!
/ anotherMathematicalName 

	^anotherMathematicalName dividedByThePotenceName: self.! !

!HumanReadablePotenceName methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 08:44'!
= anotherMathematicalName

	(self class = anotherMathematicalName class) ifFalse: [ ^false].
	
	^(self base = anotherMathematicalName base) and: (self potence = anotherMathematicalName potence).
	
! !

!HumanReadablePotenceName methodsFor: 'converting' stamp: 'GuillermoAres 6/6/2012 02:59'!
asString

	^(coloquialForPotencies of: self potence), base.! !

!HumanReadablePotenceName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 02:13'!
base
	^ base! !

!HumanReadablePotenceName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 02:13'!
base: anObject
	base := anObject! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 08:27'!
dividedByADifferentPotenceName: anotherPotenceName 
	
	^HumanReadableRatioName withNumerador: anotherPotenceName andDenominador: self.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 03:59'!
dividedBySamePotenceName: anotherHumanReadableUnitName

	^HumanReadablePotenceName named: self base withAPotenceOf: self potence - anotherHumanReadableUnitName potence.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 07:29'!
dividedByThePotenceName: anotherPotenceName

	"Ac podra haber hecho una clase por cada nombre y tipo de  unidad y haber aplicado double dispatch, pero me pareci un despropsito dado que hubieran sido demasiadas clases"

	(self base = anotherPotenceName base) 
		ifTrue: [ ^self dividedBySamePotenceName: anotherPotenceName]
		ifFalse: [ ^self dividedByADifferentPotenceName: anotherPotenceName]! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:19'!
dividedByTheProductName: aProductName

	^HumanReadableRatioName withNumerador: self andDenominador: aProductName.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:35'!
dividedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: aRatioName denominador * self andDenominador: aRatioName numerador.! !

!HumanReadablePotenceName methodsFor: 'initialization' stamp: 'GuillermoAres 6/6/2012 02:18'!
initialize

	coloquialForPotencies := ColoquialForPotenciesDictionary new.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 05:11'!
multipliedByADifferentPotenceName: aPotenceName.

	^HumanReadableProductName new
		addFactor: aPotenceName;
		addFactor: self.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:00'!
multipliedBySamePotenceName: anotherHumanReadableUnitName

	^HumanReadablePotenceName named: self base withAPotenceOf: self potence + anotherHumanReadableUnitName potence.! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 07:29'!
multipliedByThePotenceName: anotherPotenceName

	"Ac podra haber hecho una clase por cada nombre y tipo de  unidad y haber aplicado double dispatch, pero me pareci un despropsito dado que hubieran sido demasiadas clases"

	(self base = anotherPotenceName base) 
		ifTrue: [ ^self multipliedBySamePotenceName: anotherPotenceName]
		ifFalse: [ ^self multipliedByADifferentPotenceName: anotherPotenceName]! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 05:41'!
multipliedByTheProductName: aProductName

	^HumanReadableProductName withFactors: (aProductName factors add: self).! !

!HumanReadablePotenceName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:23'!
multipliedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: self * aRatioName numerador dividedBy: aRatioName denominador.! !

!HumanReadablePotenceName methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 23:52'!
potence
	^ potence! !

!HumanReadablePotenceName methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 23:52'!
potence: aPotence
	potence := aPotence.! !

HumanReadableMathematicalName subclass: #HumanReadableProductName
	instanceVariableNames: 'factors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!HumanReadableProductName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 05:42'!
withFactors: aFactor

	^HumanReadableProductName new
		addFactor: aFactor.! !

!HumanReadableProductName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 04:29'!
* anotherMathematicalName

	^anotherMathematicalName multipliedByTheProductName: self.! !

!HumanReadableProductName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 04:29'!
/ anotherMathematicalName

	^anotherMathematicalName dividedByTheProductName: self.! !

!HumanReadableProductName methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 08:41'!
= anotherMathematicalName

	(self class = anotherMathematicalName class) ifFalse: [^false].

	^(self factors = anotherMathematicalName factors).! !

!HumanReadableProductName methodsFor: 'adding' stamp: 'GuillermoAres 6/6/2012 05:11'!
addFactor: aPotenceName 
	
	factors add: aPotenceName.	! !

!HumanReadableProductName methodsFor: 'converting' stamp: 'GuillermoAres 6/6/2012 08:17'!
asString

	"Ya no me da la cabeza para ver cmo printear esto bien..."

	| resultString | 
	
	resultString := ''.

     factors do: [ :each | resultString := resultString, each asString] separatedBy: [ resultString := resultString, 'times'].

	^resultString.
	
	! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:32'!
dividedByThePotenceName: aPotenceName

	^HumanReadableRatioName withNumerador: self andDenominador: aPotenceName.! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:33'!
dividedByTheProductName: aProductName

	^HumanReadableRatioName withNumerador: self andDenominador: aProductName.! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:34'!
dividedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: self * aRatioName denominador andDenominador: aRatioName numerador.! !

!HumanReadableProductName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 03:33'!
factors
	^ factors! !

!HumanReadableProductName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 03:33'!
factors: anObject
	factors := anObject! !

!HumanReadableProductName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 04:48'!
initialize

	factors := FactorContainer new.! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 07:04'!
multipliedByThePotenceName: aPotenceName

	^(HumanReadableProductName withFactors: self factors) addFactor: aPotenceName.! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:36'!
multipliedByTheProductName: aProductName

	^HumanReadableProductName withFactors: self factors * aProductName factors.! !

!HumanReadableProductName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:37'!
multipliedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: self * aRatioName numerador andDenominador: aRatioName denominador.! !

HumanReadableMathematicalName subclass: #HumanReadableRatioName
	instanceVariableNames: 'numerador denominador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!HumanReadableRatioName class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 04:50'!
withNumerador: aNumerador
andDenominador: aDenominador
	
	^HumanReadableRatioName new
		numerador: aNumerador;
		denominador: aDenominador.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:40'!
* anotherMathematicalName

	^anotherMathematicalName multipliedByTheRatioName: self.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:40'!
/ anotherMathematicalName

	^anotherMathematicalName dividedByTheRatioName: self.! !

!HumanReadableRatioName methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 08:43'!
= anotherMathematicalName

	(self class = anotherMathematicalName class) ifFalse: [^false].
	
	^(self numerador = anotherMathematicalName numerador) and: (self denominador = anotherMathematicalName denominador). ! !

!HumanReadableRatioName methodsFor: 'converting' stamp: 'GuillermoAres 6/6/2012 04:57'!
asString
	
	^numerador asString, 'by', denominador asString.! !

!HumanReadableRatioName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 08:29'!
denominador

	^ denominador! !

!HumanReadableRatioName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 05:47'!
denominador: aMathematicalName 

	denominador := aMathematicalName! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:42'!
dividedByThePotenceName: aPotenceName

	^HumanReadableRatioName withNumerador: self numerador andDenominador: self denominador * aPotenceName.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:42'!
dividedByTheProductName: aProductName

	^HumanReadableRatioName withNumerador: self numerador andDenominador: self denominador * aProductName.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:45'!
dividedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: self numerador * aRatioName denominador andDenominador: self denominador * aRatioName numerador.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 08:28'!
multipliedByThePotenceName: aPotenceName

	^HumanReadableRatioName withNumerador: (self numerador * aPotenceName) andDenominador: self denominador.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:45'!
multipliedByTheProductName: aProductName

	^HumanReadableRatioName withNumerador: self numerador * aProductName andDenominador: self denominador.! !

!HumanReadableRatioName methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 04:45'!
multipliedByTheRatioName: aRatioName

	^HumanReadableRatioName withNumerador: self numerador * aRatioName numerador andDenominador: self denominador * aRatioName denominador.! !

!HumanReadableRatioName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 08:29'!
numerador

	^ numerador! !

!HumanReadableRatioName methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 05:47'!
numerador: aMathematicalName 

	numerador := aMathematicalName! !

Object subclass: #Measure
	instanceVariableNames: 'unit magnitude'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 07:21'!
in: aUnit withAMagnitudeOf: aMagnitude

	^Measure new
		unit: aUnit;
		magnitude: aMagnitude.! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 06:59'!
* aFactor
	
	^aFactor multiplyMeasure: self.! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 08:19'!
+ anotherMeasure

	| resultingDistance |
	resultingDistance := self expressedIn: anotherMeasure unit.
	resultingDistance magnitude: resultingDistance magnitude + anotherMeasure magnitude.
	^resultingDistance! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/5/2012 01:21'!
- anotherDistance 
	| resultingDistance |
	
	resultingDistance := self expressedIn: anotherDistance unit. 
	resultingDistance magnitude: resultingDistance magnitude - anotherDistance magnitude.
	^resultingDistance.! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 06:43'!
/ aDivisor
	
	^aDivisor divideMeasure: self.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:47'!
< anotherDistance
	^(self expressedIn: anotherDistance unit) magnitude < anotherDistance magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:47'!
<= anotherDistance 
	^(self expressedIn: anotherDistance unit) magnitude <= anotherDistance magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 05:51'!
= anotherMeasure

	(self == anotherMeasure) ifTrue:  [^true].
	(self class = anotherMeasure class) ifFalse: [^false].

	^(self unit type = anotherMeasure unit type) and: (self expressedInTheReferenceUnit) magnitude = (anotherMeasure expressedInTheReferenceUnit) magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'GuillermoAres 6/6/2012 01:18'!
> anotherMeasure 
	^(self expressedIn: anotherMeasure unit) magnitude > anotherMeasure magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
>= anotherDistance
	^(self expressedIn: anotherDistance unit) magnitude >= anotherDistance magnitude.! !

!Measure methodsFor: 'intervals' stamp: 'AresJamardo 5/30/2012 19:49'!
between: aLowerBound and: anUpperBound

	^aLowerBound < self and: self < anUpperBound.! !

!Measure methodsFor: 'exceptions' stamp: 'GuillermoAres 6/4/2012 00:58'!
canNotConvertMeasurementException

	^CanNotConvertMeasurement signal.! !

!Measure methodsFor: 'conversion' stamp: 'GuillermoAres 6/2/2012 18:21'!
conversionFunctionTo: anotherUnit 

	^self unit conversionFunctionTo: anotherUnit.! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 06:47'!
divideMeasure: anotherMeasure 
	
	^Measure in: anotherMeasure unit / self unit withAMagnitudeOf: anotherMeasure magnitude / self magnitude.! !

!Measure methodsFor: 'conversion' stamp: 'GuillermoAres 6/6/2012 08:35'!
expressedIn: anotherUnit
	
	(self unit type = anotherUnit type) ifFalse: [ self canNotConvertMeasurementException ].
	
	^Measure in: anotherUnit withAMagnitudeOf: ((self conversionFunctionTo: anotherUnit) value: self magnitude).! !

!Measure methodsFor: 'conversion' stamp: 'GuillermoAres 6/5/2012 01:34'!
expressedInTheReferenceUnit
	
	^Measure in: self unit referenceUnit withAMagnitudeOf: (self unit toReferenceUnitConversionFunction value: self magnitude).! !

!Measure methodsFor: 'comparing' stamp: 'GuillermoAres 6/4/2012 01:02'!
hash
	
	^self expressedInTheReferenceUnit magnitude.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:49'!
isZero
	^magnitude = 0.! !

!Measure methodsFor: 'intervals' stamp: 'GuillermoAres 6/6/2012 06:12'!
last: aDistance 
	^MeasureInterval first: self last: aDistance.! !

!Measure methodsFor: 'intervals' stamp: 'GuillermoAres 6/6/2012 06:13'!
last: aBound increment: aStepDistance 
	^MeasureInterval first: self last: aBound increment: aStepDistance.! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
magnitude

	^ magnitude! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
magnitude: aSmallInteger 

	magnitude := aSmallInteger! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:48'!
max: anotherDistance
	^self >= anotherDistance ifTrue: self ifFalse: anotherDistance.! !

!Measure methodsFor: 'comparing' stamp: 'AresJamardo 5/30/2012 19:48'!
min: anotherDistance 
	^self <= anotherDistance ifTrue: self ifFalse: anotherDistance.! !

!Measure methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 07:03'!
multiplyMeasure: aMeasure 
	
	^Measure in: self unit * aMeasure unit withAMagnitudeOf: self magnitude * aMeasure magnitude.! !

!Measure methodsFor: 'arithmetic' stamp: 'AresJamardo 5/30/2012 19:47'!
negated
	magnitude := magnitude negated! !

!Measure methodsFor: 'printing' stamp: 'GuillermoAres 6/6/2012 02:17'!
printOn: aStream

	self magnitude printOn: aStream.
	aStream nextPutAll: ' '; nextPutAll: self unit name asString.
	magnitude > 1 ifTrue: [aStream nextPutAll: 's'].! !

!Measure methodsFor: 'intervals' stamp: 'GuillermoAres 6/6/2012 06:14'!
to: aMeasure 
	^self last: aMeasure.! !

!Measure methodsFor: 'intervals' stamp: 'GuillermoAres 6/6/2012 06:16'!
to: lowerBound by: upperBound 
	^self last: lowerBound increment: upperBound.! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
unit

	^ unit! !

!Measure methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:48'!
unit: aDistanceUnit 

	unit := aDistanceUnit! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'increment first last'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 06:10'!
first: aBound last: anotherBound 
	^self new first: aBound; last: anotherBound; increment: (Measure in: aBound unit withAMagnitudeOf: 1).! !

!MeasureInterval class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 06:10'!
first: aBound last: anotherBound increment: aStepDistance
	^(self first: aBound last: anotherBound) increment: aStepDistance.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:49'!
by
	^increment.! !

!MeasureInterval methodsFor: 'enumerating' stamp: 'GuillermoAres 6/6/2012 06:08'!
do: aBlockClosure 

	| actualValue lowerBound upperBound  |
	lowerBound := last min: first.
	upperBound := last max: first.
	
	actualValue := lowerBound.
	
	[actualValue <= upperBound] whileTrue: 
									[ aBlockClosure value: actualValue. 
										actualValue := actualValue + increment].! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
first

	^ first! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
first: aBound

	first := aBound.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:48'!
from
	^first.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
increment
	
	^increment! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
increment: aStepDistance

	increment := aStepDistance.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
last

	^ last! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
last: aBound 
	last := aBound.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:08'!
size
	
	^(last - first expressedIn: increment unit) magnitude / increment magnitude + 1.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'GuillermoAres 6/6/2012 06:48'!
to
	^last.! !

Object subclass: #Unit
	instanceVariableNames: 'name type toReferenceUnitConversionFunction fromReferenceUnitConversionFunction referenceUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Unit class methodsFor: 'known temperature units' stamp: 'GuillermoAres 6/5/2012 22:29'!
celsius
	^ Unit
		toBeUsedAsReferenceFor: 'temperature' named: 'celsius'.! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:57'!
centimeters
	^ Unit
		named: 'centimeter'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 1 / 100 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 100 ]! !

!Unit class methodsFor: 'known time units' stamp: 'GuillermoAres 6/5/2012 01:15'!
days

	^Unit
		named: 'day' 
		withTheReferenceUnit: Unit seconds
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 24 * 60 * 60] 		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 24 / 60 / 60].! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:57'!
decameters
	^ Unit
		named: 'decameter'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 10 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 10 ]! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:57'!
decimeters
	^ Unit
		named: 'decimeter'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 1 / 10 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 10 ]! !

!Unit class methodsFor: 'known temperature units' stamp: 'GuillermoAres 6/5/2012 00:57'!
fahrenheits

	^Unit 
		named: 'fahrenheit'
		withTheReferenceUnit: Unit celsius
		withTheToReferenceUnitConversionFunction: [: aMagnitude | (aMagnitude - 32) * (5/9)] 
		andTheFromReferenceUnitConversionFunction: [: aMagnitude | (aMagnitude * (9/5)) + 32].! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:58'!
hectometers
	^ Unit
		named: 'hectometer'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 100 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 100 ]! !

!Unit class methodsFor: 'known time units' stamp: 'GuillermoAres 6/5/2012 01:16'!
hours

	^Unit
		named: 'hour' 
		withTheReferenceUnit: Unit seconds 
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 60 * 60] 		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 60 / 60].! !

!Unit class methodsFor: 'known temperature units' stamp: 'GuillermoAres 6/5/2012 01:27'!
kelvins
	
	^Unit
		named: 'kelvin' 
		withTheReferenceUnit: Unit celsius 
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude - 273] 		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude + 273].! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:58'!
kilometers
	^ Unit
		named: 'kilometer'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 1000 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 1000 ]! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 22:30'!
meters
	^ Unit
		toBeUsedAsReferenceFor: 'distance' named: 'meter'.! !

!Unit class methodsFor: 'known distance units' stamp: 'GuillermoAres 6/5/2012 00:58'!
millimeters
	^ Unit
		named: 'millimeter'
		withTheReferenceUnit: Unit meters
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude / 1000 ]
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude * 1000 ]! !

!Unit class methodsFor: 'known time units' stamp: 'GuillermoAres 6/5/2012 00:58'!
minutes

	^Unit 
		named: 'minute' 
		withTheReferenceUnit: Unit seconds
		withTheToReferenceUnitConversionFunction: [:aMagnitude | aMagnitude * 60] 
		andTheFromReferenceUnitConversionFunction: [: aMagnitude | aMagnitude / 60].! !

!Unit class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 05:55'!
named: aUnitMathematicalName 
toRepresent: aUnitTypeMathematicalName
withTheToReferenceUnitConversionFunction: toReferenceUnitConversionFunction 
andTheFromReferenceUnitConversionFunction: fromReferenceUnitConversionFunction 

	| newUnit |

	newUnit := Unit new
		name: aUnitMathematicalName;
		type: aUnitTypeMathematicalName;
		toReferenceUnitConversionFunction: toReferenceUnitConversionFunction;
		fromReferenceUnitConversionFunction: fromReferenceUnitConversionFunction.
		
	newUnit referenceUnit: newUnit.
	
	^newUnit.! !

!Unit class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 00:47'!
named: unitName 
withTheReferenceUnit: aReferenceUnit
withTheToReferenceUnitConversionFunction: aToReferenceUnitConversionFunction 
andTheFromReferenceUnitConversionFunction: aFromReferenceUnitConversionFunction
	
	^Unit new
		name: (HumanReadablePotenceName knownAs: unitName); 
		referenceUnit: aReferenceUnit;
		type: aReferenceUnit type;
		toReferenceUnitConversionFunction: aToReferenceUnitConversionFunction;
		fromReferenceUnitConversionFunction: aFromReferenceUnitConversionFunction.! !

!Unit class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 01:03'!
named: aHumanReadablePotenceName 
withTheToReferenceUnitConversionFunction: toReferenceUnitConversionFunction 
andTheFromReferenceUnitConversionFunction: fromReferenceUnitConversionFunction 

	^Unit new
		name: aHumanReadablePotenceName;
		toReferenceUnitConversionFunction: toReferenceUnitConversionFunction;
		fromReferenceUnitConversionFunction: fromReferenceUnitConversionFunction.! !

!Unit class methodsFor: 'known time units' stamp: 'GuillermoAres 6/5/2012 00:55'!
seconds
	^ Unit
		toBeUsedAsReferenceFor: 'time' named: 'second'.! !

!Unit class methodsFor: 'instanciating' stamp: 'GuillermoAres 6/6/2012 07:24'!
toBeUsedAsReferenceFor: aUnitTypeName named: unitName 
	
	| newUnit |
	
	newUnit := Unit new.
	
	newUnit
		name: (HumanReadablePotenceName knownAs: unitName);
		referenceUnit: newUnit;
		type: (HumanReadableMathematicalName knownAs: aUnitTypeName);
		toReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude];
		fromReferenceUnitConversionFunction: [ :aMagnitude | aMagnitude].
		
	^newUnit.! !

!Unit methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 01:07'!
* anotherUnit 
	^Unit
		named: (HumanReadableMathematicalName forProductBetween: self name and: anotherUnit name) 
		toRepresent: (HumanReadableMathematicalName forProductBetween: self type and: anotherUnit type)
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | self toReferenceUnitConversionFunction value: (anotherUnit toReferenceUnitConversionFunction value: aMagnitude)] 
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | self fromReferenceUnitConversionFunction value: (anotherUnit fromReferenceUnitConversionFunction value: aMagnitude)]! !

!Unit methodsFor: 'arithmetic' stamp: 'GuillermoAres 6/6/2012 03:08'!
/ anotherUnit 
	^Unit
		named: (HumanReadableMathematicalName forRatioBetween: self name and: anotherUnit name) 
		toRepresent: (HumanReadableMathematicalName forRatioBetween: self type and: anotherUnit type)
		withTheToReferenceUnitConversionFunction: [ :aMagnitude | self toReferenceUnitConversionFunction value: (anotherUnit toReferenceUnitConversionFunction value: aMagnitude)] 
		andTheFromReferenceUnitConversionFunction: [ :aMagnitude | self fromReferenceUnitConversionFunction value: (anotherUnit fromReferenceUnitConversionFunction value: aMagnitude)]! !

!Unit methodsFor: 'comparing' stamp: 'GuillermoAres 6/4/2012 01:57'!
= anotherUnit
	
	^(self class = anotherUnit class) 
		and: (self type = anotherUnit type)
		and: (self toReferenceUnitConversionFunction value: 7) = (anotherUnit toReferenceUnitConversionFunction value: 7).! !

!Unit methodsFor: 'converting' stamp: 'GuillermoAres 6/6/2012 06:02'!
adaptToNumber: aNumber andSend: selector 
	
	^(Measure in: self withAMagnitudeOf: 1) perform: selector with: aNumber.! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/4/2012 02:01'!
conversionFunctionTo: anotherUnit

	^[:aMagnitude | anotherUnit fromReferenceUnitConversionFunction value: (self toReferenceUnitConversionFunction value: aMagnitude)]! !

!Unit methodsFor: 'converting' stamp: 'GuillermoAres 6/2/2012 18:23'!
fromReferenceUnitConversionFunction

	^fromReferenceUnitConversionFunction.! !

!Unit methodsFor: 'converting' stamp: 'GuillermoAres 6/2/2012 18:52'!
fromReferenceUnitConversionFunction: aFunction

	fromReferenceUnitConversionFunction := aFunction.! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 19:37'!
name
	^ name! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 22:16'!
name: aName
	name := aName.! !

!Unit methodsFor: 'printing' stamp: 'GuillermoAres 6/5/2012 22:16'!
printOn: aStream

	self name printOn: aStream.! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/4/2012 02:38'!
referenceUnit
	^ referenceUnit
! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 00:09'!
referenceUnit: aReferenceUnit
	referenceUnit := aReferenceUnit! !

!Unit methodsFor: 'accessing' stamp: 'AresJamardo 5/30/2012 20:29'!
toReferenceUnitConversionFunction

	^toReferenceUnitConversionFunction.
	! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/2/2012 18:52'!
toReferenceUnitConversionFunction: aFunction

	toReferenceUnitConversionFunction  := aFunction.! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 00:56'!
type
	^ type
! !

!Unit methodsFor: 'accessing' stamp: 'GuillermoAres 6/5/2012 00:56'!
type: aUnitType
	type := aUnitType! !
